/**
 * Write a description of class Ghost here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
import java.util.*;
public class Ghost  
{
    private boolean up, right, down, left;
    private Point pos;
    private int dir;
    private int type;
    
    public Ghost(Point p, int t)
    {
        pos = p;
        dir = (int)(Math.random() * 3 + 1);
        type = t;
    }
    public Point getPos()
    {
        return pos;
    }
    public void setPos(Point pnt)
    {
        pos = pnt;
    }
    private void check(ArrayList<String> a)
    {
        if (pos.getX() <= 0 && a.get(pos.getY()).charAt(36) != '#' && a.get(pos.getY()).charAt(36) != '=')
            left = true;
        else if (pos.getX() == 0)
            left = false;
        else if (a.get(pos.getY()).charAt(pos.getX() - 1) != '#' && a.get(pos.getY()).charAt(pos.getX() - 1) != '=')
            left = true;
        else
            left = false;
        if (pos.getX() >= 36 && a.get(pos.getY()).charAt(0) != '#' && a.get(pos.getY()).charAt(0) != '=')
            right = true;
        else if (pos.getX() == 36)
            right = false;
        else if (a.get(pos.getY()).charAt(pos.getX() + 1) != '#' && a.get(pos.getY()).charAt(pos.getX() + 1) != '=')
            right = true;
        else
            right = false;
        if (pos.getY() <= 0 && a.get(11).charAt(pos.getX()) != '#' && a.get(11).charAt(pos.getX()) != '=')
            up = true;
        else if (pos.getY() == 0)
            up = false;
        else if (a.get(pos.getY() - 1).charAt(pos.getX()) != '#' && a.get(pos.getY() - 1).charAt(pos.getX()) != '=')
            up = true;
        else
            up = false;
        if (pos.getY() >= 11 && a.get(0).charAt(pos.getX()) != '#' && a.get(0).charAt(pos.getX()) != '=')
            down = true;
        else if (pos.getY() == 11)
            down = false;
        else if (a.get(pos.getY() + 1).charAt(pos.getX()) != '#' && a.get(pos.getY() + 1).charAt(pos.getX()) != '=')
            down = true;
        else
            down = false;
    }
    public void move(ArrayList<String> a)
    {
        if (type == 1)
            moveRegular(a);
        else
            moveClockwise(a);
    }
    private void moveRegular(ArrayList<String> a)
    {
        check(a);
        int n = (int)(Math.random() * 3 + 1);
        String str;
        if (dir == 1)
        {
            if (n == 1 && up)
                dir = 3;
            else if (n == 2 && down)
                dir = 4;
            else
            {
                if (right && up && down)
                    str = "234";
                else if (right && up)
                    str = "23";
                else if (right && down)
                    str = "24";
                else
                    str = "34";
                if (pos.getX() <= 0 && left)
                    pos = new Point(36, pos.getY());
                else if (pos.getX() == 0)
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
                else if (left)
                    pos.move(-1, 0);
                else
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
            }
        }
        else if (dir == 2)
        {
            if (n == 1 && up)
                dir = 3;
            else if (n == 2 && down)
                dir = 4;
            else
            {
                if (left && up && down)
                    str = "134";
                else if (left && up)
                    str = "13";
                else if (left && down)
                    str = "14";
                else
                    str = "34";
                if (pos.getX() >= 36 && right)
                    pos = new Point(0, pos.getY());
                else if (pos.getX() == 36)
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
                else if (right)
                    pos.move(1, 0);
                else
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
            }
        }
        else if (dir == 3)
        {
            if (n == 1 && left)
                dir = 1;
            else if (n == 2 && right)
                dir = 2;
            else
            {
                if (left && right && down)
                    str = "124";
                else if (left && right)
                    str = "12";
                else if (left && down)
                    str = "14";
                else
                    str = "24";
                if (pos.getY() <= 0 && up)
                    pos = new Point(pos.getX(), 11);
                else if (pos.getY() == 0)
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
                else if (up)
                    pos.move(0, -1);
                else
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
            }
        }
        else if (dir == 4)
        {
            if (n == 1 && left)
                dir = 1;
            else if (n == 2 && right)
                dir = 2;
            else
            {
                if (left && right && up)
                    str = "123";
                else if (left && right)
                    str = "12";
                else if (left && up)
                    str = "13";
                else
                    str = "23";
                if (pos.getY() >= 11 && down)
                    pos = new Point(pos.getX(), 0);
                else if (pos.getY() == 11)
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
                else if (down)
                    pos.move(0, 1);
                else
                    dir = Integer.parseInt(str.charAt((int)(Math.random() * (str.length() - 1) + 1) - 1) + "");
            }
        }
    }
    private void moveClockwise(ArrayList<String> a)
    {
        check(a);
        if (dir == 1)
        {
            if (pos.getX() <= 0 && left)
                pos = new Point(36, pos.getY());
            else if (pos.getX() == 0)
            {
                if (type == 2)
                    dir = 3;
                else if (type == 3)
                    dir = 4;
            }
            else if (left)
                pos.move(-1, 0);
            else
            {
                if (type == 2)
                    dir = 3;
                else if (type == 3)
                    dir = 4;
            }
        }
        else if (dir == 2)
        {
            if (pos.getX() >= 36 && right)
                pos = new Point(0, pos.getY());
            else if (pos.getX() == 36)
            {
                if (type == 2)
                    dir = 4;
                else if (type == 3)
                    dir = 3;
            }
            else if (right)
                pos.move(1, 0);
            else
            {
                if (type == 2)
                    dir = 4;
                else if (type == 3)
                    dir = 3;
            }
        }
        else if (dir == 3)
        {
            if (pos.getY() <= 0 && up)
                pos = new Point(pos.getX(), 11);
            else if (pos.getY() == 0)
            {
                if (type == 2)
                    dir = 2;
                else if (type == 3)
                    dir = 1;
            }
            else if (up)
                pos.move(0, -1);
            else
            {
                if (type == 2)
                    dir = 2;
                else if (type == 3)
                    dir = 1;
            }
        }
        else if (dir == 4)
        {
            if (pos.getY() >= 11 && down)
                pos = new Point(pos.getX(), 0);
            else if (pos.getY() == 11)
            {
                if (type == 2)
                    dir = 1;
                else if (type == 3)
                    dir = 2;
            }
            else if (down)
                pos.move(0, 1);
            else
            {
                if (type == 2)
                    dir = 1;
                else if (type == 3)
                    dir = 2;
            }
        }
    }
}