/**
 * Write a description of class Point here.
 * 
 * @author Taylor Born
 * @version March 2010
 */
public class Point  
{
    private int x, y;
    
    public Point(int a, int b)
    {
        x = a;
        y = b;
    }
    public Point(Point p)
    {
        x = p.getX();
        y = p.getY();
    }
    public int getX()
    {
        return x;
    }
    public int getY()
    {
        return y;
    }
    public void move(int a, int b)
    {
        x += a;
        y += b;
    }
    public boolean equals(Point other)
    {
        return x == other.getX() && y == other.getY();
    }
}