import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Screen here.
 * 
 * @author Taylor Born
 * @version November 2010
 */
import java.awt.Color;
public class Screen  extends World
{
    private Logo myLogo = new Logo();
    private boolean started = false;

    public Screen()
    {
        super(500, 400, 1);
        setPaintOrder(CodeDisplay.class, Button.class, ListBox.class, ControlBox.class);
        GreenfootImage back = new GreenfootImage(500, 400);
        back.fill();
        setBackground(back);
        CodeKeyUser.enter();
        Greenfoot.start();
    }
    public void act()
    {
        if (!started && Greenfoot.mouseMoved(this))
        {
            addObject(myLogo, 250, 200);
            started = true;
        }
        if (myLogo != null)
            if (myLogo.done())
            {
                GreenfootImage back = new GreenfootImage(500, 400);
                back.setColor(Color.WHITE);
                back.fill();
                setBackground(back);
                removeObject(myLogo);
                myLogo = null;
                addObject(new ControlBox(), 250, 200);
            }
    }
}